Sumário

# Instrução GoSub...Return

Chama uma sub-rotina indicada pelo rótulo dentro de uma Sub ou Function. As instruções subsequentes ao rótulo são executadas até a próxima instrução Return. O programa continua a execução, então, com a instrução que segue a instrução GoSub .

### Sintaxe:

    GoSub label[:]

### Parâmetros:

label: um identificador da linha onde continuar a execução. O escopo do identificador é o da rotina que ele pertence.

A instrução GoSub chama uma sub-rotina local indicada por um rótulo de dentro de uma sub-rotina ou função. O nome do rótulo deve terminar com um sinal de dois-pontos (":").

      Sub/Function foo
          ' instruções
          GoSub label
          ' instruções
          Exit Sub/Function
      label:
          ' instruções
          Return
      End Sub/Function

Se o programa encontra uma instrução Return não precedida por GoSub, o LibreOffice Basic retorna uma mensagem de erro. Use Exit Sub ou a Função Exit para garantir que o programa deixe uma Sub-rotina ou uma Função antes de chegar à próxima instrução Return.

O exemplo a seguir demonstra o uso de GoSub e Return. Executando duas vezes a seção de um programa, o programa calcula a raiz quadrada dos dois números inseridos pelo usuário.

### Exemplo:

    Sub ExampleGoSub
    Dim iInputa As Single
    Dim iInputb As Single
    Dim iInputc As Single
        iInputa = Int(InputBox("Digite o primeiro número: ","NumberInput"))
        iInputb = Int(InputBox("Digite o segundo número: ","NumberInput"))
        iInputc=iInputa
        GoSub SquareRoot
        Print "A raiz quadrada de ";iInputa;" é";iInputc
        iInputc=iInputb
        GoSub SquareRoot
        Print "A raiz quadrada de ";iInputb;" é";iInputc
        Exit Sub
    SquareRoot:
        iInputc=sqr(iInputc)
        Return
    End Sub

Tópicos relacionados

Instrução GoTo

Instrução On...GoSub; Instrução On...GoTo

♥ Doe para nosso projeto! ♥